
#ifndef INC_H
#define INC_H
#ifdef __cplusplus
extern "C" {
#endif

//---------------------------------------------------------------------------

#include "header\gba.h"

#include "header\bg.h"
#include "header\blend.h"
#include "header\dma.h"
#include "header\irq.h"
#include "header\sound.h"
#include "header\sprite.h"
#include "header\timer.h"

//#include "header\font\BGFont.h"
//#include "header\font\BitMapFont.h"

#include "res\resource.h"

//---------------------------------------------------------------------------
#define FIX_POWER				64

#define INT2FIX(A)				( (A) * FIX_POWER )
#define FIX2INT(A)				( _Div((A), FIX_POWER) )
#define FIX_MUL(A,B)			( _Div(((A) * (B)), FIX_POWER) )
#define FIX_DIV(A,B)			( _Div(((A) * FIX_POWER), (B)) )

#define PI						INT2FIX(3.14)				//3.141592654f

//---------------------------------------------------------------------------
#define STATE_INIT 				1							//is
#define STATE_RESET				2
#define STATE_READY				3
#define STATE_GAME				4

#define MYSHIP_MAX_X			INT2FIX(120)				//ړ͈
#define MYSHIP_MAX_Y			INT2FIX(80)
#define MYSHIP_MAX_ROLL			20							//[͈
#define MYSHIP_VROLL			1							//[x

#define MYSHIP_BEAM_MAX_TIME	4							//r[̑ҋ@
#define MYSHIP_SHOT_MAX_TIME	6							//Vbg̑ҋ@
#define MYSHIP_BEAM_MIN_POWER	15							//r[̃p[
#define MYSHIP_SHOT_MAX_GAUGE	15							//Vbg̃Q[W

#define BEAM_MAX_CNT			12
#define SHOT_MAX_CNT			30
#define BULLET_MAX_CNT			512

#define DOUBLER_LINE_CY			8
#define DOUBLER_BLOCK_CNT		20							//SCREEN_CY / DOUBLER_LINE_CY
#define DOUBLER_OBJ_CNT			120
#define DOUBLER_BULLET_CNT		512

//---------------------------------------------------------------------------
typedef struct {
	s16 x;
	s16 y;
	s16 roll;			//[
	s16 shotGauge;		//Vbg̃Q[W
	s16 shotTime;		//ҋ@
	s16 beamPower;		//r[̃p[
	s16 beamTime;		//ҋ@
	u8  sprNo;
} ST_MYSHIP;

typedef struct {
//	f32  x;
	s16  y;
} ST_BEAM;

typedef struct {
	s16  x;
	s16  y;
	s16  vx;
	s16  vy;
} ST_SHOT;

typedef struct {
	s16  x;
	s16  y;
	s16  vx;
	s16  vy;
	u16  timer;
	void (*pMove)(void*);
} ST_BULLET;

typedef struct {
	u16 attr0;
	u16 attr1;
	u16 attr2;
	u16 attr3;
} ST_OBJ;

typedef struct {
	ST_OBJ  obj   [DOUBLER_BULLET_CNT];
	u16     objCnt[DOUBLER_BLOCK_CNT];
} ST_DOBULER;


//---------------------------------------------------------------------------


#ifdef __cplusplus
}
#endif
#endif

