
#include "inc.h"

#include "lib.h"
#include "main.h"
#include "iwram_arm.h"
#include "div_arm.h"

#include "iwram_arm.h"

//---------------------------------------------------------------------------
//lib.c
extern ST_TIMER Timer;

//main.c
extern ST_BULLET Bullet[BULLET_MAX_CNT];
extern u16       BulletCnt;
//---------------------------------------------------------------------------
ST_DOBULER Doubler[2];			//_uobt@Q
u8         DoublerSideSw;		//_uobt@̐؂ւXCb`

u32        DoublerCopySrc;		//XvCgւ̃Rs[p
u32        DoublerCopyDst;
u8         DoublerCopyCnt;

u8         DoublerVCnt;			//VCOUNT
u8         NextVCnt;

u32        DummyU32;
//---------------------------------------------------------------------------
IWRAM_CODE void IRQUserHandler()
{
	REG_IME  = IRQ_MASTER_OFF;
	u16 flag = REG_IF;

	if(flag & IRQ_BIT_TIMER0)
	{
		Timer.clockTick += TIMER_INTMS;
	}
	else if(flag & IRQ_BIT_VCOUNT)
	{
		if(REG_VCOUNT == SCREEN_CY)
		{
			DoublerCopySrc = (u32)&Doubler[DoublerSideSw].obj[0];
			DoublerCopyDst = (u32)OAMmem + 8*8;
			DoublerCopyCnt = 0;

			DoublerVCnt    = 0;
			NextVCnt       = 0;
		}
		else	//vcount < SCREEN_CY
		{
			//8CPʂŃ_ũRs[܂
			DoublerCopy();
			DoublerVCnt += 1;
			NextVCnt    += DOUBLER_LINE_CY;
		}

		REG_DISPSTAT = (REG_DISPSTAT & 0x003f) | DSTAT_VCOUNT_LINE(NextVCnt);
	}

	REG_IF  = flag;
	REG_IME = IRQ_MASTER_ON;
}
//---------------------------------------------------------------------------
IWRAM_CODE void DoublerChange()
{
	DoublerClear(DoublerSideSw);
	DoublerSideSw ^= 0x01;
}
//---------------------------------------------------------------------------
IWRAM_CODE void DoublerClear(u8 sw)
{
	//obj
	REG_DM1SAD = (u32)&DummyU32;
	REG_DM1DAD = (u32)&Doubler[sw].obj[0];
	REG_DM1CNT = (DOUBLER_BULLET_CNT * 4)
	             | ( (DMA_SIZE_16 | DMA_TRANSFER_ON | DMA_TIMING_NOW | DMA_REPEAT_OFF |
	                  DMA_SAD_FIX | DMA_DAD_INC     | DMA_INTR_OFF) << 16 );
	//objCnt
	REG_DM3SAD = (u32)&DummyU32;
	REG_DM3DAD = (u32)&Doubler[sw].objCnt[0];
	REG_DM3CNT = (DOUBLER_BLOCK_CNT)
	             | ( (DMA_SIZE_16 | DMA_TRANSFER_ON | DMA_TIMING_NOW |  DMA_REPEAT_OFF |
	                  DMA_SAD_FIX | DMA_DAD_INC     | DMA_INTR_OFF) << 16 );
}
//---------------------------------------------------------------------------
IWRAM_CODE void DoublerCopy()
{
	//Doubler to OAM
	u32 regCnt1 = Doubler[DoublerSideSw].objCnt[DoublerVCnt];
	u32 regCnt2 = 0;

	//DMA]pɃJEg𕪊܂
	if((DoublerCopyCnt + regCnt1) > DOUBLER_OBJ_CNT)
	{
		regCnt2 = (DoublerCopyCnt + regCnt1) - DOUBLER_OBJ_CNT;
		regCnt1 = DOUBLER_OBJ_CNT - DoublerCopyCnt;
	}

	if(regCnt1 > 0)
	{
		REG_DM0SAD = DoublerCopySrc;
		REG_DM0DAD = DoublerCopyDst;
		REG_DM0CNT = (regCnt1 * 4)
		             | ( (DMA_SIZE_16 | DMA_TRANSFER_ON | DMA_TIMING_HBLANK | DMA_REPEAT_OFF |
		                  DMA_SAD_INC | DMA_DAD_INC     | DMA_INTR_OFF) << 16 );

		DoublerCopySrc += (regCnt1 * 8);
		DoublerCopyDst += (regCnt1 * 8);
		DoublerCopyCnt +=  regCnt1;
	}

	if(regCnt2 > 0)
	{
		REG_DM2SAD = DoublerCopySrc;
		REG_DM2DAD = (u32)OAMmem + 8*8;
		REG_DM2CNT = (regCnt2 * 4)
		             | ( (DMA_SIZE_16 | DMA_TRANSFER_ON | DMA_TIMING_HBLANK | DMA_REPEAT_OFF |
		                  DMA_SAD_INC | DMA_DAD_INC     | DMA_INTR_OFF) << 16 );

		DoublerCopySrc += (regCnt2 * 8);
		DoublerCopyDst  = (u32)OAMmem + 8*8 + (regCnt2 * 8);
		DoublerCopyCnt  = regCnt2;
	}
}
//---------------------------------------------------------------------------
IWRAM_CODE void BulletCalc()
{
	u8 sw = DoublerSideSw ^ 0x01;

	ST_OBJ* pObj[DOUBLER_BLOCK_CNT];
	s16     i;

	//ꂼ̃ubN̒ɓo^ĂXvCg̐g
	//o^\̃|C^ݒ肵܂
	pObj[0] = &Doubler[sw].obj[0];
	for(i=1; i<DOUBLER_BLOCK_CNT; i++)
	{
		pObj[i] = pObj[i-1] + Doubler[sw].objCnt[i-1];
	}

	//ꂼ̃ubN̒ɃXvCgo^Ă܂
	for(i=0; i<BulletCnt; i++)
	{
		u8 x      = CommonToFieldX(Bullet[i].x) - 4;	//4́ASHOT_CX / 2
		u8 y      = CommonToFieldY(Bullet[i].y) - 4;
		u8 idx    = y / DOUBLER_LINE_CY;
		ST_OBJ* p = pObj[idx];

		p->attr0 &= 0x1fff;
		p->attr1 &= 0x3fff;
		p->attr0 |= SP_COLOR_16 | SP_SQUARE;
		p->attr1 |= SP_SIZE_8;

		p->attr2 &= 0xfc00;
		p->attr2 |= 68;

		p->attr1 &= 0xfe00;
		p->attr0 &= 0xff00;
		p->attr1 |= (x & 0x01ff);
		p->attr0 |= (y & 0x00ff);

		pObj[idx]++;
	}

	cprint("Bullet = ");
	cprintf(BulletCnt);
}
//---------------------------------------------------------------------------
IWRAM_CODE void BulletMove()
{
	u8  sw = DoublerSideSw ^ 0x01;
	s16 i;

	for(i=0; i<BulletCnt; i++)
	{
		Bullet[i].pMove( &Bullet[i] );

		u8 y   = CommonToFieldY(Bullet[i].y) - 4;
		u8 idx = y / DOUBLER_LINE_CY;
		u8 cnt = Doubler[sw].objCnt[idx];

		//TODO Ȃ
		if( (CommonOut(Bullet[i].x, Bullet[i].y, 4) == TRUE) || (cnt >= DOUBLER_OBJ_CNT) || y >= 160)
		{
			Bullet[i].x     = Bullet[BulletCnt-1].x;
			Bullet[i].y     = Bullet[BulletCnt-1].y;
			Bullet[i].vx    = Bullet[BulletCnt-1].vx;
			Bullet[i].vy    = Bullet[BulletCnt-1].vy;
			Bullet[i].timer = Bullet[BulletCnt-1].timer;
			Bullet[i].pMove = Bullet[BulletCnt-1].pMove;

			BulletCnt--;
			i--;
			continue;
		}
		Doubler[sw].objCnt[idx]++;
	}
}
//---------------------------------------------------------------------------
//e + _e
IWRAM_CODE void BulletMoveDir(ST_BULLET* p)
{
	p->x += p->vx;
	p->y += p->vy;
}
//---------------------------------------------------------------------------
//e
IWRAM_CODE void BulletMoveSplit(ST_BULLET* p)
{
	p->timer++;

	p->x += p->vx;
	p->y += p->vy;

	if(p->timer > 10)
	{
		BulletNew(p->x, p->y, 54, (void*)&BulletMoveDir);
		BulletNew(p->x, p->y, 64, (void*)&BulletMoveDir);
		BulletNew(p->x, p->y, 74, (void*)&BulletMoveDir);

		BulletCnt--;
		*p = Bullet[BulletCnt];
	}
}
//---------------------------------------------------------------------------
inline IWRAM_CODE u16 CommonToFieldX(s16 x)
{
	return (120 + FIX2INT(x));
}
//---------------------------------------------------------------------------
inline IWRAM_CODE u16 CommonToFieldY(s16 y)
{
	return (80 + FIX2INT(y));
}
