
#ifndef MAIN_H
#define MAIN_H
#ifdef __cplusplus
extern "C" {
#endif

//---------------------------------------------------------------------------
EWRAM_CODE void StateInit(); 
EWRAM_CODE void StateReset();
EWRAM_CODE void StateGame();

EWRAM_CODE void InitWS();
EWRAM_CODE void InitKey();
EWRAM_CODE void InitIRQ();
EWRAM_CODE void InitSprite();
EWRAM_CODE void InitDoubler();

EWRAM_CODE void MoveMain();
EWRAM_CODE void DrawMain();
EWRAM_CODE void ProdMain();
EWRAM_CODE void CalcMain();

EWRAM_CODE u16  CommonScanKey();
EWRAM_CODE u8   CommonGetAngle(s16 fx1, s16 fy1, s16 fx2, s16 fy2);
EWRAM_CODE bool CommonOut(s16 fx, s16 fy, s16 fsize);

//----
EWRAM_CODE void MyShipInit();
EWRAM_CODE void MyShipNew(s16 x, s16 y);
EWRAM_CODE void MyShipShot();
EWRAM_CODE void MyShipBeam();
EWRAM_CODE void MyShipDeleteBeam();
EWRAM_CODE void MyShipMove();
EWRAM_CODE void MyShipDraw();

//----
EWRAM_CODE void BeamInit();
EWRAM_CODE void BeamNew(s16 y);
EWRAM_CODE void BeamMove();

//----
EWRAM_CODE void ShotInit();
EWRAM_CODE void ShotNew(s16 x, s16 y, s16 dir);
EWRAM_CODE void ShotMove();

//----
EWRAM_CODE void BulletInit();
EWRAM_CODE void BulletNew(s16 x, s16 y, s16 dir, void pMove(void*));


#ifdef __cplusplus
}
#endif
#endif
